<?php

namespace XF\Job;

use XF\Entity\ProfilePostComment;
use XF\Mvc\Entity\Entity;
use XF\Service\Message\PreparerService;

class ProfilePostCommentEmbedMetadata extends AbstractEmbedMetadataJob
{
	protected function getIdsToRebuild(array $types)
	{
		return $this->getIdsBug153298Workaround('profile_post_comment');
	}

	protected function getRecordToRebuild($id)
	{
		return $this->app->em()->find(ProfilePostComment::class, $id);
	}

	protected function getPreparerContext()
	{
		return 'profile_post_comment';
	}

	protected function getMessageContent(Entity $record)
	{
		return $record->message;
	}

	protected function rebuildAttachments(Entity $record, PreparerService $preparer, array &$embedMetadata)
	{
		$embedMetadata['attachments'] = $preparer->getEmbeddedAttachments();
	}

	protected function rebuildImages(Entity $record, PreparerService $preparer, array &$embedMetadata): void
	{
		$embedMetadata['images'] = $preparer->getEmbeddedImages();
	}

	protected function getActionDescription()
	{
		$rebuildPhrase = \XF::phrase('rebuilding');
		$type = \XF::phrase('profile_post_comments');
		return sprintf('%s... %s', $rebuildPhrase, $type);
	}
}
